/* 페이징 관련 변수 */
let webPhotoDietTotalCount   = 0;
let webPhotoDietTotalPages   = 0;

/*aggird*/
let webPhotoDietAgGridData = [];

let webPhotoDietSelectId = "";
let webPhotoDietSelectCategoryNo = "";

/****************************************************************************
 * 검색 날짜 설정
 //(A:오늘, B:3일, C:7일, D:최근30일, E:최근90일, F:이번달, G:올해, H:지난주, I:지난달)
 ****************************************************************************/
function fn_webPhotoDietSetDate(param){
    if("A"==param){
        // 오늘
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchStartDate = year+'-'+month+'-'+day;
        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;
    }
    else if("B"==param){
        // 3일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 3);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("C"==param){
        // 이번주
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 7);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("D"==param){
        // 최근30일
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        //최근30일
        toDate.setDate(toDate.getDate() - 30);
        startYear  = toDate.getFullYear();
        startMonth = toDate.getMonth() + 1;
        startDay   = toDate.getDate();

        if(startMonth < 10) startMonth = "0" + startMonth;
        if(startDay < 10) startDay = "0" + startDay;

        webPhotoDietSearchStartDate = startYear+'-'+startMonth+'-'+startDay;
        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

    }
    else if("E"==param){
        // 최근90일
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        toDate.setDate(toDate.getDate() - 90);
        year  = toDate.getFullYear();
        month = toDate.getMonth() + 1;
        day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchStartDate = year+'-'+month+'-'+day;
    }
    else if("F"==param){
        //F:이번달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webPhotoDietSearchStartDate = year+'-'+month+'-01';
    }
    else if("G"==param){
        // G:올해
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webPhotoDietSearchStartDate = year+'-01-01';
    }
    else if("H"==param){
        // H:지난주, I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webPhotoDietSearchStartDate = year+'-01-01';
    }
    else if("I"==param){
        // I:지난달
        // 검색 종료일자
        let toDate = new Date();
        let year  = toDate.getFullYear();
        let month = toDate.getMonth() + 1;
        let day   = toDate.getDate();

        if(month < 10) month = "0" + month;
        if(day < 10) day = "0" + day;

        webPhotoDietSearchEndDate   = year+'-'+month+'-'+day;

        // 검색 시작일자
        webPhotoDietSearchStartDate = year+'-01-01';
    }

    $("#webPhotoDietSearchStartDate").val(webPhotoDietSearchStartDate).trigger("change");
    $("#webPhotoDietSearchEndDate").val(webPhotoDietSearchEndDate).trigger("change");
}


/****************************************************************************
 * 전후 사진(다이어트) 정보 리스트 조회
 ****************************************************************************/
function fn_selectListWebPhotoDietJson(){
    let formData = new FormData();
    formData.append("menuClass", menuClass);
    formData.append("webPhotoDietSearchKeywordParam0", webPhotoDietSearchKeywordParam0);
	formData.append("webPhotoDietSearchKeywordParam1", webPhotoDietSearchKeywordParam1);
	formData.append("webPhotoDietSearchKeywordParam2", webPhotoDietSearchKeywordParam2);
	formData.append("webPhotoDietSearchKeywordParam3", webPhotoDietSearchKeywordParam3);
    formData.append("webPhotoDietSort", webPhotoDietSort);
    formData.append("webPhotoDietDir", webPhotoDietDir);
    formData.append("webPhotoDietStart", webPhotoDietStart);
    formData.append("webPhotoDietLimit", webPhotoDietLimit);
    formData.append("webPhotoDietSearchStartDate", webPhotoDietSearchStartDate);
    formData.append("webPhotoDietSearchEndDate", webPhotoDietSearchEndDate);
    formData.append("webPhotoDietSearchDateType", webPhotoDietSearchDateType);

    $.ajax({
        url: encodeURI('/webphotodiet/selectListWebPhotoDiet.do'),
        data: formData,
        dataType: "json",
        processData: false,
        contentType: false,
        type: 'POST',
        async: true,
        success: function(data){
            if('0'==data.msgCode){
                // 페이징 처리
                webPhotoDietTotalCount  = data.totalCount;
                //$("#txt_noticeTotalCount").text(noticeTotalCount);

                webPhotoDietTotalPages = Math.ceil(webPhotoDietTotalCount/webPhotoDietLimit);

                // 리스트 조회
                webPhotoDietAgGridData = data.rows;
                webPhotoDietGridOptions.api.setRowData(webPhotoDietAgGridData);

                if(0<data.rows.length){
                    //페이징 처리
                    window.pagObj = $('#webPhotoDietPagination').twbsPagination({
                        startPage    : ((webPhotoDietStart/webPhotoDietLimit)+1),
                        totalPages   : (webPhotoDietTotalPages==0)?1:webPhotoDietTotalPages,
                        visiblePages : 10,
                        initiateStartPageClick: false,
                        prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev"/>',
                        next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next"/>',
                        first        : '',
                        last         : '',
                        onPageClick: function (photodiet, page) {
                            fn_webPhotoDietPagination(page);
                        }
                    }).on('page', function (photodiet, page) {
                        //console.info(page + ' (from photodiet listening)');
                    });
                }
                else{

                }
            }
            else{
                modalEvent.danger("조회 오류", data.msgDesc);
            }
        },
        error : function(xhr, status, error) {
            modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
        },
        beforeSend:function(){
            // 로딩열기
            webPhotoDietGridOptions.api.showLoadingOverlay();
        },
        complete:function(){

        }
    });
}

/****************************************************************************
 * 검색하기
 ****************************************************************************/
function fn_webPhotoDietSearch(param){
    if("A"!=param && "Y"!=selectUseYn){
        modalEvent.warning("", "조회 권한이 없습니다.");
        return false;
    }

    fn_webPhotoDietPaginReset();

    webPhotoDietSearchKeywordParam0 = $("#webPhotoDietSearchKeyword0").val();
	webPhotoDietSearchKeywordParam1 = $("#webPhotoDietSearchKeyword1").val();
	webPhotoDietSearchKeywordParam2 = $("#webPhotoDietSearchKeyword2").val();
	webPhotoDietSearchKeywordParam3 = $("#webPhotoDietSearchKeywordParam3").val();

    webPhotoDietSearchDateType  = $("#webPhotoDietSearchDateType").val();
    webPhotoDietSearchStartDate = $("#webPhotoDietSearchStartDate").val();
    webPhotoDietSearchEndDate   = $("#webPhotoDietSearchEndDate").val();

    fn_selectListWebPhotoDietJson();
}


/****************************************************************************
 * 초기화하기
 ****************************************************************************/
function fn_webPhotoDietReset(){
    fn_webPhotoDietSetDate('D');
    $("#webPhotoDietSearchDateType option:eq(0)").prop("selected", true);

    $("#webPhotoDietSearchKeyword0").val("");
	$("#webPhotoDietSearchKeyword1").val("");
	$("#webPhotoDietSearchKeyword2").val("");
	$("#webPhotoDietSearchKeyword3").val("");

    fn_webPhotoDietSearch();
}

/****************************************************************************
 * 페이징 처리
 ****************************************************************************/
function fn_webPhotoDietPagination(param){
    webPhotoDietStart = (parseInt(param)-1)*webPhotoDietLimit;

    fn_selectListWebPhotoDietJson();
}

/****************************************************************************
 * 페이징 리셋
 ****************************************************************************/
function fn_webPhotoDietPaginReset(){
    webPhotoDietSearchKeywordParam0 = '';
	webPhotoDietSearchKeywordParam1 = '';
	webPhotoDietSearchKeywordParam2 = '';
	webPhotoDietSearchKeywordParam3 = '';

    webPhotoDietStart        = 0;
    webPhotoDietLimit        = 100;
    webPhotoDietTotalCount   = 0;
    webPhotoDietTotalPages   = 0;

    //페이징 초기화
    if($("#webPhotoDietPagination").data("twbs-pagination")){
        $("#webPhotoDietPagination").twbsPagination("destroy");
    }
}

/****************************************************************************
 * 전후 사진(다이어트) 삭제
 ****************************************************************************/
function fn_deleteWebPhotoDiet(){
    if("Y"!=deleteUseYn){
        modalEvent.warning("", "삭제 권한이 없습니다.");
        return false;
    }

    if(!webPhotoDietSelectId){
        modalEvent.warning("", "삭제할 대상을 선택하세요.");
        return false;
    }

    // categoryno 값 가져오기 (여러 개일 수 있음)
    let selectRows = webPhotoDietGridOptions.api.getSelectedRows();
    let categoryNos = selectRows.map(function(row) { return row.categoryno; }).join(",");

    modalEvent.info("삭제", "선택한 전후 사진(다이어트) 정보를 삭제하시겠습니까?", function(){
        let formData = new FormData();
        formData.append("menuClass", menuClass);
        formData.append("selectId", webPhotoDietSelectId);
        formData.append("categoryno", categoryNos); // categoryno 추가

        $.ajax({
            url: encodeURI('/webphotodiet/deleteWebPhotoDiet.do'),
            data: formData,
            dataType: "json",
            processData: false,
            contentType: false,
            type: 'POST',
            async: true,
            success: function(data){
                if('0'==data.msgCode){
                    modalEvent.success("삭제 성공", data.msgDesc, function(){
                        fn_webPhotoDietOk();
                    });
                }
                else{
                    modalEvent.danger("삭제 오류", data.msgDesc);
                }
            },
            error : function(xhr, status, error) {
                modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
            },
            beforeSend:function(){

            },
            complete:function(){

            }
        });
    });
}

/****************************************************************************
 * 검색 엔터 전후 사진(다이어트)
 ****************************************************************************/
function fn_webPhotoDietEnter(e){
    if(e.which){
        // 파이어폭스
        if(13 == e.which) {
            //로그인 액션 스크립트
            fn_webPhotoDietSearch();
        }
    }
    else{
        // 윈도우, 사파리, 크롬
        if(13 == photodiet.keyCode) {
            //로그인 액션 스크립트
            fn_webPhotoDietSearch();
        }
    }
}

/****************************************************************************
 * 정렬 전후 사진(다이어트)
 ****************************************************************************/
function fn_alignPhotoDiet(param, param2){
    let align = "";

    if("A"==param){
        align = "오늘";

        fn_webPhotoDietSetDate('A');
    }
    else if("B"==param){
        align = "최근30일";

        fn_webPhotoDietSetDate('D');
    }
    else if("C"==param){
        align = "최근90일";

        fn_webPhotoDietSetDate('E');
    }
    else if("D"==param){
        align = "이번주";

        fn_webPhotoDietSetDate('C');
    }
    else if("E"==param){
        align = "이번달";

        fn_webPhotoDietSetDate('F');
    }
    else if("F"==param){
        align = "올해";

        fn_webPhotoDietSetDate('G');
    }
    else if("G"==param){
        align = "지난주";

        fn_webPhotoDietSetDate('H');
    }
    else if("H"==param){
        align = "지난달";

        fn_webPhotoDietSetDate('I');
    }
    else{
        align = "";
    }
    $("#webPhotoDietSearchDateType").val(param);
    $("#webPhotoDietSearchDateType").siblings("button").text(align);
}

/****************************************************************************
 * 완료
 ****************************************************************************/
function fn_webPhotoDietOk(){
    fn_webPhotoDietReset();
}

/****************************************************************************
 * 등록 화면으로 이동.
 ****************************************************************************/
function fn_insertWebPhotoDietIntro(){
    if("Y"==insertUseYn){
        let pagingParam = "?menuClass="+menuClass;
        fn_leftFormAction("/webphotodiet/insertWebPhotoDietIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "등록 권한이 없습니다.");
        return false;
    }

}

/****************************************************************************
 * 수정 화면으로 이동.
 ****************************************************************************/
function fn_updateWebPhotoDietIntro(muWebPhotoDietId, categoryno){
    if("Y"==updateUseYn){
        let pagingParam = "?menuClass="+menuClass;
        pagingParam    += "&muWebPhotoDietId="+muWebPhotoDietId;
		pagingParam    += "&categoryno="+categoryno;
        fn_leftFormAction("/webphotodiet/updateWebPhotoDietIntro.do"+pagingParam);
    }else{
        modalEvent.warning("", "수정 권한이 없습니다.");
        return false;
    }
}


let webPhotoDietColumnDefs = [
    {field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},    
    {field: "rowNum", headerName:"번호", minWidth:60, maxWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
	{field: "category", headerName:"카테고리", minWidth:60},
    {field: "title", headerName:"제목", minWidth:150, cellStyle:{cursor: 'pointer', color:'#3985EA'}},    
	{field: "content", headerName:"내용요약", minWidth:150},
	{field: "hashtag", headerName:"해시태그", minWidth:150},
    {field: "writeDate", headerName:"등록일",minWidth:100, maxWidth:150},
    {field: "writeName", headerName:"작성자",minWidth:100, maxWidth:150},
];

// let the grid know which columns and what data to use
let webPhotoDietGridOptions = {
    suppressRowTransform: true,
    columnDefs: webPhotoDietColumnDefs,
    defaultColDef: {		// 리스트 기본 설정
        flex: 1,
        sortable: true,		//정렬 여부
        resizable: true,	//리사이즈
        editable: true,	// 그리드에서 데이터 수정
        cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
        //suppressSizeToFit:true,		//자동 맞춤
        //enableRowGroup: true,		// 그룹 묶음
        enablePivot: true,
        enableValue : true
    },
    //suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
    headerHeight : 41, // header 높이
    rowHeight : 41, // row 높이
    rowData : webPhotoDietAgGridData,
    suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
    localeText : {
        noRowsToShow : '조회 결과가 없습니다.'
    }, //데이터 없을 시 나오는 문구
    rowSelection : 'multiple', // row 다중 선택
    debug : false,
    onCellClicked: function(photodiet){ //셀 클릭 전후 사진(다이어트)
        /* alert(photodiet.column.colId); */
        if('title'==photodiet.column.colId){
            fn_updateWebPhotoDietIntro(photodiet.data.muWebPhotoDietId, photodiet.data.categoryno);
        }
    },
    onSelectionChanged: function(photodiet){ //체크박스 선택
        let selectRows = [];
        selectRows = photodiet.api.getSelectedRows();

        webPhotoDietSelectId = '';
        for(let i=0; i<selectRows.length; i++){
            webPhotoDietSelectId += selectRows[i].muWebPhotoDietId + ",";
        }
        webPhotoDietSelectId = webPhotoDietSelectId.substring(0, webPhotoDietSelectId.lastIndexOf(','));
    },
    onSortChanged: function(photodiet){
        //정렬
        webPhotoDietSort = ''; //기존 정렬 초기화
        let columnArr = photodiet.columnApi.getColumnState();
        if(0<columnArr.length){
            //sort index 순으로 재정렬
            columnArr.sort(function(a,b){
                return a.sortIndex - b.sortIndex;
            });

            let nullCnt = 0;
            for(let i=0; i<columnArr.length; i++){
                let gridSortModel = columnArr[i].colId;
                let gridSort = columnArr[i].sort;

                if(gridSort != null){
                    webPhotoDietStart = 0;
                    webPhotoDietSort += gridSortModel+' '+ gridSort + ',';
                }
                else{
                    nullCnt++;
                    if(nullCnt == columnArr.length){
                        webPhotoDietSort = '';
                        webPhotoDietDir = '';
                        webPhotoDietStart = 0;
                    }
                }
            }
        }
        webPhotoDietSort = webPhotoDietSort.substring(0,webPhotoDietSort.lastIndexOf( ",")); //맨끝 콤마 지우기

        fn_webPhotoDietSearch();
    }
};

// lookup the container we want the Grid to use
let webPhotoDietGridDiv = document.querySelector('#webPhotoDietGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(webPhotoDietGridDiv, webPhotoDietGridOptions);





/****************************************************************************
 * 페이지 init
 ****************************************************************************/
function fn_pageInit(){
    // 날짜 datepicker
    fn_searchDatePicker("#divWebPhotoDietSearchStartDate", "#divWebPhotoDietSearchEndDate");

    if(!webPhotoDietSearchStartDate&&!webPhotoDietSearchEndDate){
        // 검색 오늘날짜 셋팅
        fn_webPhotoDietSetDate('D');
    }else{
        $("#webPhotoDietSearchStartDate").val(webPhotoDietSearchStartDate).trigger("change");
        $("#webPhotoDietSearchEndDate").val(webPhotoDietSearchEndDate).trigger("change");
    }

    // 초기 페이징 처리
    $("#webPhotoDietSearchKeyword0").val(webPhotoDietSearchKeywordParam0);
	$("#webPhotoDietSearchKeyword1").val(webPhotoDietSearchKeywordParam1);
	$("#webPhotoDietSearchKeyword2").val(webPhotoDietSearchKeywordParam2);
	$("#webPhotoDietSearchKeyword3").val(webPhotoDietSearchKeywordParam3);

    fn_webPhotoDietSearch("A");
}

/****************************************************************************
 * 페이지 photodiet
 ****************************************************************************/
function fn_pagePhotoDiet(){
    // 검색 input
    $(document).on('keypress', '#webPhotoDietSearchKeyword0', function(e) {
        fn_webPhotoDietEnter(e);
    });
	// 검색 input
    $(document).on('keypress', '#webPhotoDietSearchKeyword1', function(e) {
        fn_webPhotoDietEnter(e);
    });
	// 검색 input
    $(document).on('keypress', '#webPhotoDietSearchKeyword2', function(e) {
        fn_webPhotoDietEnter(e);
    });
	// 검색 input
    $(document).on('keypress', '#webPhotoDietSearchKeyword3', function(e) {
        fn_webPhotoDietEnter(e);
    });

    // 검색 조회 버튼
    $("#btnSearchWebPhotoDiet").click(function () {
        fn_webPhotoDietSearch();
    });

    // 전후 사진(다이어트) 등록 팝업 버튼
    $("#btnInsertWebPhotoDiet").click(function () {
        fn_insertWebPhotoDietIntro();
    });

    // 전후 사진(다이어트) 삭제 버튼
    $("#btnDeleteWebPhotoDiet").click(function () {
        fn_deleteWebPhotoDiet();
    });

    // 기간 선택 콤보 전후 사진(다이어트)
    const target = $("#webPhotoDietSearchDateType").siblings("ul.select_option_list");
    target.find("li.option_list_item").click(function () {
        let selectIdArr = $(this).prop("id").split('_');
        let selectId    = selectIdArr[1];
        let selectName  = $(this).text();

        $(this).parent().siblings("button").text(selectName);
        $(this).parent().siblings("input").val(selectId);

        fn_alignPhotoDiet(selectId);
    });
}

$(function(){
    // 페이지 init
    fn_pageInit();

    // 페이지 photodiet
    fn_pagePhotoDiet();
});